
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ai_chat_messagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ai_chat_messages = await db.ai_chat_messages.create(
            {
                id: data.id || undefined,
        
        sender: data.sender
        ||
        null
            ,
            
        message_text: data.message_text
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ai_chat_messages.setAi_chat_session( data.ai_chat_session || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.ai_chat_messages.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: ai_chat_messages.id,
            },
            data.attachments,
            options,
        );
        

        return ai_chat_messages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ai_chat_messagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                sender: item.sender
            ||
            null
            ,
            
                message_text: item.message_text
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ai_chat_messages = await db.ai_chat_messages.bulkCreate(ai_chat_messagesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < ai_chat_messages.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.ai_chat_messages.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: ai_chat_messages[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return ai_chat_messages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const ai_chat_messages = await db.ai_chat_messages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.sender !== undefined) updatePayload.sender = data.sender;
        
        
        if (data.message_text !== undefined) updatePayload.message_text = data.message_text;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await ai_chat_messages.update(updatePayload, {transaction});

        
        
        if (data.ai_chat_session !== undefined) {
            await ai_chat_messages.setAi_chat_session(
              
              data.ai_chat_session,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.ai_chat_messages.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: ai_chat_messages.id,
            },
            data.attachments,
            options,
        );
        

        return ai_chat_messages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ai_chat_messages = await db.ai_chat_messages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ai_chat_messages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ai_chat_messages) {
                await record.destroy({transaction});
            }
        });


        return ai_chat_messages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ai_chat_messages = await db.ai_chat_messages.findByPk(id, options);

        await ai_chat_messages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ai_chat_messages.destroy({
            transaction
        });

        return ai_chat_messages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ai_chat_messages = await db.ai_chat_messages.findOne(
            { where },
            { transaction },
        );

        if (!ai_chat_messages) {
            return ai_chat_messages;
        }

        const output = ai_chat_messages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.ai_chat_session = await ai_chat_messages.getAi_chat_session({
            transaction
        });
        
        
        output.attachments = await ai_chat_messages.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.ai_chat_sessions,
        as: 'ai_chat_session',
        
        where: filter.ai_chat_session ? {
          [Op.or]: [
            { id: { [Op.in]: filter.ai_chat_session.split('|').map(term => Utils.uuid(term)) } },
            {
              summary: {
                [Op.or]: filter.ai_chat_session.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.message_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ai_chat_messages',
                        'message_text',
                        filter.message_text,
                    ),
                };
            }
            

            
            

            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.sender) {
                where = {
                    ...where,
                sender: filter.sender,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ai_chat_messages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ai_chat_messages',
                        'message_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ai_chat_messages.findAll({
            attributes: [ 'id', 'message_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['message_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.message_text,
        }));
    }

    
};

